#include <stdio.h>
#include <stdlib.h>

unsigned int ile_z_pola(unsigned int x, unsigned int y, unsigned int C, unsigned int R, 
			unsigned char *labi[], unsigned char *nostart[])
{
    unsigned int max=0, tmp;
    
    labi[x][y] = '#';
    if (x>0 && labi[x-1][y]=='.') {
	max = (max>(tmp=ile_z_pola(x-1,y,C,R,labi,nostart))) ? max : tmp+1;
	nostart[x][y] = 1;
    }
    if (y>0 && labi[x][y-1]=='.') {
	max = (max>(tmp=ile_z_pola(x,y-1,C,R,labi,nostart))) ? max : tmp+1;
	nostart[x][y] = 1;
    }
    if (x<R && labi[x+1][y]=='.') {
	max = (max>(tmp=ile_z_pola(x+1,y,C,R,labi,nostart))) ? max : tmp+1;
	nostart[x][y] = 1;
    }
    if (y<C && labi[x][y+1]=='.') {
	max = (max>(tmp=ile_z_pola(x,y+1,C,R,labi,nostart))) ? max : tmp+1;
	nostart[x][y] = 1;
    }
    labi[x][y]='.';
    return max;
}

unsigned int max_rlen(unsigned int C, unsigned int R, 
			unsigned char *labi[], unsigned char *nostart[])
{
    unsigned int max=0,tmp,i,j;
    
    for (i=0; i<C; i++)
	for (j=0; j<R; j++)
	    if (labi[j][i] == '.' && !nostart[j][i])
		max = (max>(tmp=ile_z_pola(j,i,C,R,labi,nostart))) ? max : tmp;
   return max;
}

main()
{
  unsigned int T;
  unsigned int C,R;
  unsigned char *labi[1000];
  unsigned char *nostart[1000];
  unsigned int z,i;
  scanf("%u\n",&T);
  for (z=0; z<T; z++)
  {
    scanf("%u %u\n",&C,&R);
    for (i=0; i<R; i++) {
	labi[i] = (unsigned char *)calloc(C+1, sizeof(char));
	nostart[i] = (unsigned char *)calloc(C+1, sizeof(char));
	scanf("%s",labi[i]);
    }
    printf("Maximum rope length is %d.\n",max_rlen(C,R,labi,nostart));
    for (i=0; i<R; i++)
	free(labi[i]);
	free(nostart[i]);
  }
  return 0;
}
